#include <stdio.h>
#include <jaguar.h>
#include <jagfont.h>
#include <jagvid.h>
#include <jagobj.h>

#define PPP           4 /* Pixels per Phrase (1-bit) */
#define BMP_WIDTH   320 /* Width in Pixels */
#define BMP_HEIGHT  200 /* Height in Pixels */
#define BMP_PHRASES (BMP_WIDTH/PPP)
#define SCREENSIZE 128000
#define LISTSIZE 5 /* List length (in phrases) */


/* interen Variablen */
ObjPhrase *_ObjListBuf;
ObjBitmapBackupEntry *_BitmapBackup;
int CurX, CurY;
unsigned char *screenpt;


void Init(void)
{  int i;

   /* create object list and screen (bitmap) */
   _ObjListBuf = (ObjPhrase *)malloc(LISTSIZE * sizeof(ObjPhrase));
   _BitmapBackup = (ObjBitmapBackupEntry *)malloc(sizeof(ObjBitmapBackupEntry));
   screenpt = (char *)malloc(SCREENSIZE);
   /* init screen */
   *(unsigned short int *) 0xf00400 = 0x0000; /* Color reg 0 = black */
   *(unsigned short int *) 0xf00402 = 0xffff; /* Color reg 1 = white */
   memset(screenpt, 0, SCREENSIZE);
   /* init object list with screen bitmap */
   ObjCreateBranch(_ObjListBuf, VidVde, O_BRLT, _ObjListBuf + 4);
   ObjCreateBranch(_ObjListBuf + 1, VidVdb, O_BRGT, _ObjListBuf + 4);
   ObjCreateBitmap(_ObjListBuf + 2, (VidHeight - BMP_HEIGHT + VidVdb) & 0xFFFE,
                   BMP_HEIGHT, _ObjListBuf + 4, (void *)screenpt,
                   ((VidWidth >> 2) - BMP_WIDTH) >> 1, O_DEPTH16, O_NOGAP,
                   BMP_PHRASES, BMP_PHRASES, 0, 0, 0, 0, 0, 0);
   ObjCreateStop(_ObjListBuf + 4, O_STOPINTS);
   ObjBackupBitmap(_BitmapBackup, _ObjListBuf + 2);
   /* sneacky trick to cause display to popup at first VB */
   _ObjListBuf[2].high_long = 0;
   _ObjListBuf[2].low_long = 0xC;
   /* init other Variables */
   CurX = 0;
   CurY = 0;
   /* start object processor */
   ObjInitVbint();
   ObjSetOlp(_ObjListBuf, 1, _BitmapBackup);
}

#define FNT_WIDTH  6
#define FNT_HEIGHT 12

static void ChrOut(int c)
{  char string[] = " ";

   string[0] = c;
   FntStr((CurX + 1) * FNT_WIDTH, (CurY + 1) * FNT_HEIGHT, string, (void *)screenpt,
          PIXEL16 | PITCH1 | ZOFFS2 | WID320, clr6x12, 0xffff, 0);
   CurX++;
}


int main(int argc, char *argv[])
{
   Init();
   ChrOut('H');
   ChrOut('e');
   ChrOut('l');
   ChrOut('l');
   ChrOut('o');
   ChrOut(' ');
   ChrOut('w');
   ChrOut('o');
   ChrOut('r');
   ChrOut('l');
   ChrOut('d');
   for(;;);  /* Infinite Loop.  Alpine users can delete this.  */
   return(0);
}
